Panda3D

- Main Page
- Packages
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Static Public Member Functions

# TypedWritableReferenceCount Class Reference

A base class for things which need to inherit from both TypedWritable and from ReferenceCount. More...

Inheritance diagram for TypedWritableReferenceCount:

List of all members.

## Static Public Member Functions
static TypedWritableReferenceCount | decodeFromBamStream (string data, BamReader reader)
| Reads the string created by a previous call to encode_to_bam_stream(), and extracts and returns the single object on that string.
static TypedWritableReferenceCount | decodeFromBamStream (string data)
| Reads the string created by a previous call to encode_to_bam_stream(), and extracts and returns the single object on that string.
static TypeHandle | getClassType ()

## Detailed Description

A base class for things which need to inherit from both TypedWritable and from ReferenceCount.

It's convenient to define this intermediate base class instead of multiply inheriting from the two classes each time they are needed, so that we can sensibly pass around pointers to things which are both TypedWritables and ReferenceCounters.

See also TypedObject for detailed instructions.

## Member Function Documentation

static TypedWritableReferenceCount decodeFromBamStream | ( | string | data,
|  | BamReader | reader
| ) |  | `[static]`

Reads the string created by a previous call to encode_to_bam_stream(), and extracts and returns the single object on that string.

Returns NULL on error.

This method is intended to replace decode_raw_from_bam_stream() when you know the stream in question returns an object of type TypedWritableReferenceCount, allowing for easier reference count management. Note that the caller is still responsible for maintaining the reference count on the return value.

static TypedWritableReferenceCount decodeFromBamStream | ( | string | data | ) | `[static]`

Reads the string created by a previous call to encode_to_bam_stream(), and extracts and returns the single object on that string.

Returns NULL on error.

This method is intended to replace decode_raw_from_bam_stream() when you know the stream in question returns an object of type TypedWritableReferenceCount, allowing for easier reference count management. Note that the caller is still responsible for maintaining the reference count on the return value.

static TypeHandle getClassType | ( |  | ) | `[static]`

Reimplemented from ReferenceCount.

Reimplemented in PGMouseWatcherParameter, PGMouseWatcherBackground, MouseWatcherRegion, BamCacheRecord, CachedTypedWritableReferenceCount, CopyOnWriteObject, NodeCachedReferenceCount, DynamicTextPage, Texture, GeomTextGlyph, Geom, GraphicsOutputBase, GraphicsStateGuardianBase, InternalName, GeomVertexArrayFormat, GeomVertexFormat, GeomVertexArrayData, VertexTransform, TransformTable, TransformBlendTable, VertexSlider, SliderTable, GeomVertexData, GeomPrimitive, TextureStage, GeomLines, GeomLinestrips, GeomPoints, GeomTriangles, GeomTrifans, GeomTristrips, Lens, Material, MatrixLens, OrthographicLens, PerspectiveLens, UserVertexSlider, UserVertexTransform, VideoTexture, EventStoreValueBase, EventStoreTypedRefCount, PointerEventList, GraphicsStateGuardian, GraphicsOutput, GraphicsWindow, CallbackGraphicsWindow, GraphicsBuffer, ParasiteBuffer, CollisionSolid, CollisionBox, CollisionEntry, CollisionPlane, CollisionFloorMesh, CollisionPolygon, CollisionSphere, CollisionInvSphere, CollisionRay, CollisionLine, CollisionParabola, CollisionSegment, CollisionTube, CharacterJoint, MovingPartMatrix, CharacterSlider, MovingPartScalar, CharacterVertexSlider, JointVertexTransform, CharacterJointBundle, PartBundle, CharacterJointEffect, RenderEffect, AnimGroup, AnimBundle, PartGroup, AnimChannelBase, AnimChannelMatrix, AnimChannelScalar, AnimChannelMatrixDynamic, AnimChannelMatrixXfmTable, AnimChannelScalarDynamic, AnimChannelScalarTable, AnimPreloadTable, MovingPartBase, MovingPartACMatrixSwitchType, MovingPartACScalarSwitchType, MovieTexture, NodeVertexTransform, MovieAudio, MovieAudioCursor, FfmpegAudio, FfmpegAudioCursor, MovieVideo, MovieVideoCursor, FfmpegVideo, FfmpegVideoCursor, InkblotVideo, InkblotVideoCursor, MicrophoneAudio, UserDataAudio, UserDataAudioCursor, TransformState, RenderAttrib, RenderModeAttrib, TexMatrixAttrib, RenderState, AlphaTestAttrib, AntialiasAttrib, RenderEffects, TransparencyAttrib, AudioVolumeAttrib, AuxBitplaneAttrib, BillboardEffect, ClipPlaneAttrib, ColorAttrib, ColorBlendAttrib, ColorScaleAttrib, ColorWriteAttrib, CompassEffect, CullBinAttrib, CullFaceAttrib, DecalEffect, DepthOffsetAttrib, DepthTestAttrib, DepthWriteAttrib, EventStorePandaNode, FogAttrib, LightAttrib, LightRampAttrib, MaterialAttrib, TextureAttrib, TexGenAttrib, OccluderEffect, PolylightEffect, ShaderInput, ShaderAttrib, ShowBoundsEffect, TexProjectorEffect, ScissorEffect, RescaleNormalAttrib, ScissorAttrib, ShadeModelAttrib, and StencilAttrib.

All Classes Namespaces Functions Variables Enumerations Enumerator Properties